<?php

$dealerObj = new dealers();

class dealers {

    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;
    public $mPrefix;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config ?? [];
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'ar';
        $this->mPrefix = $Config['prefix'] ?? '';
    }

    public function getSearchDealerCount($sort, $type, $searchDealer_id, $searchMobile, $searchCountry_id, $searchStatus, $searchEmail, $subscription_type, $searchDateFrom, $searchDateTo) {

        $sql = "SELECT COUNT(DISTINCT md.`id`) as 'result_count'   FROM  master_dealers md ";
        $sql .= " LEFT JOIN `master_subscription` ms ON ms.dealer_id = md.id   ";
        $sql .= " WHERE md.id > 0";
        $sql .= $searchEmail ? ' AND md.`email` like "%' . $searchEmail . '%"' : '';
        $sql .= $searchDealer_id ? " AND md.`id`='{$searchDealer_id}'" : '';
        $sql .= $searchMobile ? ' AND md.`mobile` like "%' . $searchMobile . '%"' : '';
        $sql .= $searchCountry_id ? " AND md.`country_id`  = '{$searchCountry_id}'  " : '';
        $sql .= $subscription_type ? " AND md.`subscription_type`  = '{$subscription_type}'  " : '';
        $sql .= $searchStatus === '0' || $searchStatus ? " AND md.`active`  = '{$searchStatus}'  " : '';
//        $sql .= $searchDateFrom ? " AND ms.`subscription_date_to` >= '{$searchDateFrom}'" : '';
//        $sql .= $searchDateTo ? " AND ms.`subscription_date_to` <= '{$searchDateTo}'" : '';
//        $sql .= " GROUP BY md.id";
        $sql .= $searchDateFrom && $searchDateTo ? " HAVING " : "";
        $sql .= $searchDateFrom ? "  `subscription_date_to`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateFrom && $searchDateTo ? " AND `subscription_date_to`  <= '{$searchDateTo}' " : "";

//        echo $sql . "<hr>";

        return $this->mDb->getOne($sql);
    }

    public function getSomeDealers($aStart, $aLimit, $sort, $type, $searchDealer_id, $searchMobile, $searchCountry_id, $searchStatus, $searchEmail, $subscription_type, $searchDateFrom, $searchDateTo
    ) {
        $sql = "SELECT DISTINCT md.id,md.full_name, md.email, md.user_name, md.active , md.date_added, md.country_id, md.mobile,md.subscription_type ,  MAX(ms.subscription_date_to) AS subscription_date_to ";
        $sql .= "  FROM `master_dealers` md ";
        $sql .= " LEFT JOIN `master_subscription` ms ON ms.dealer_id = md.id   ";
        $sql .= " WHERE md.id > 0";
        $sql .= $searchEmail ? ' AND md.`email` like "%' . $searchEmail . '%"' : '';
        $sql .= $searchDealer_id ? " AND md.id ='{$searchDealer_id}'" : '';
        $sql .= $searchMobile ? ' AND md.`mobile` like "%' . $searchMobile . '%"' : '';
        $sql .= $searchCountry_id ? " AND md.`country_id`  = '{$searchCountry_id}'  " : '';
        $sql .= $subscription_type ? " AND md.`subscription_type`  = '{$subscription_type}'  " : '';
        $sql .= $searchStatus === '0' || $searchStatus ? " AND md.`active`  = '{$searchStatus}'  " : '';
        $sql .= " GROUP BY md.`id`";
        $sql .= $searchDateFrom && $searchDateTo ? " HAVING " : "";
        $sql .= $searchDateFrom ? "  `subscription_date_to`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateFrom && $searchDateTo ? " AND `subscription_date_to`  <= '{$searchDateTo}' " : "";

        $sql .= " ORDER BY  {$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            $res[$i]['balance'] = $this->getBalanceSumByDealer($res[$i]['id']);
        }
        return $res;
    }

    public function deleteDealer($ids) {
        global $subdomain;
        global $CPAPI;
        global $Config;
        $res = false;
        $sql_2 = "";
        $sql_3 = "SELECT `user_name` FROM `master_dealers` WHERE id='0' ";
        $sql = "DELETE FROM `master_dealers` ";
        $sql .= " WHERE `id` = 0 ";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
            $sql_3 .= " || `id` = '{$id}' ";
            $sql_2 .= " || `dealer_id` = '{$id}' ";
        }

        $allDealers = $this->mDb->getAll($sql_3);
        $res = $this->mDb->query($sql);
        if ($res) {
            $sql2 = "DELETE FROM `master_shops` ";
            $sql2 .= " WHERE `dealer_id` = 0 ";
            $sql2 .= $sql_2;
            $this->mDb->query($sql2);
//            -----------------
            for ($i = 0; $i < count($allDealers); $i++) {
                $subdomain->delete($allDealers[$i]['user_name']);
                $json_CPAPI = $CPAPI->deleteDataBaseMySQL("souqalhi_affiliate_" . $allDealers[$i]['user_name']);
                deleteFolder($allDealers[$i]['user_name']);

//                    حذف روابط ال robots 
                $this->mDb->delCronJob("0 0 * * * curl -s '{$Config['cronJob_url']}cronJob/robots.php?db={$allDealers[$i]['user_name']}&lang=ar'>/dev/null 2>&1");

//                $addDb = json_decode($json_CPAPI);
//                if ($addDb->status) {
//                  return $res;  
//                }
            }
        }
        return $res;
    }

    public function getOneDealer($id) {
        $sql = "SELECT  d.id,d.plan_id,d.user_name,d.full_name,d.email,d.mobile,d.country_id,d.active,d.date_added,d.subscription_type,d.commission_rate,d.commission_value,d.minimum_commission,d.maximum_commission  FROM `master_dealers` d";
        $sql .= " WHERE d.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);

        return $res;
    }

    public function cheackIfExitByField($value, $field, $id) {
        $sql = "SELECT  id FROM `master_dealers`   ";
        $sql .= " WHERE {$field} = '{$value}'  ";
        $sql .= $id ? " AND id != '{$id}' " : '';
        //  echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    public function editDealer($temp) {
        global $Config;
        //edit
        if ($temp['password']) {
            $temp['password'] = password_hash($temp['password'], PASSWORD_DEFAULT);
        } else {
            unset($temp['password']);
        }
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['commission_rate'] = $temp['commission_rate'] ? '1' : '0';
        $sql = "UPDATE `master_dealers` SET ";
        foreach ($this->mDb->getCols('master_dealers', $temp) as $k => $v) {
            $sql .= ( $k == 'id') ? "" : "`{$k}`='{$v}',";
        }
        $sql = substr($sql, 0, -1);

        $sql .= " WHERE `id` = '{$temp['id']}'";
//          echo $sql ."<hr>";
        $res = $this->mDb->query($sql);
        if ($res) {

            try {


                $temp['user_name'] = ($temp['user_name'] != 'GOGET') ? $temp['user_name'] : "new";
                $pdo = new PDO("mysql:host=localhost;dbname=souqalhi_affiliate_" . strtolower($temp['user_name']), $Config['dbuser'], $Config['dbpwd']);
                $pdo->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
                // تحديث بيانات الادمن
                $sql_ = "UPDATE `users` SET `active`='{$temp['active']}',`mobile`='{$temp['mobile']}',`email`='{$temp['email']}'";
                $sql_ .= $temp['password'] ? ",`password`='{$temp['password']}'" : "";
                $sql_ .= " WHERE `id` = '1'";
//                echo $sql_."<hr>";
                $pdo->query($sql_);
                // تحديث بيانات المتجر
                $sql_1 = "UPDATE `users` SET `active`='{$temp['active']}',`mobile`='{$temp['mobile']}'";
                $sql_1 .= $temp['password'] ? ",`password`='{$temp['password']}'" : "";
                $sql_1 .= " WHERE `id` = '2'";
//                echo $sql_."<hr>";
                $pdo->query($sql_1);

                // تحديث  الخطة

                $pdo->query("UPDATE `users` SET `dealer_id`='{$temp['id']}' WHERE (`user_level` != '3000')");
                if ($temp['active'] == '1') {
//                  
                    //اضافة روابط robots الى الكرون جوب 
                    $this->mDb->addCronJob("0 0 * * * curl -s '{$Config['cronJob_url']}cronJob/robots.php?db={$temp['user_name']}&lang=ar'>/dev/null 2>&1");
                } else {
//                    حذف الروابط 
                    $this->mDb->delCronJob("0 0 * * * curl -s '{$Config['cronJob_url']}cronJob/robots.php?db={$temp['user_name']}&lang=ar'>/dev/null 2>&1");
                }
            } catch (PDOException $e) {
                return $e->getMessage();
            }
            $pdo = null;
        }

        return $res;
    }

    public function getDealerSubscriptionsCount($sort, $type, $searchDealer_id, $transaction_type, $searchDateFrom, $searchDateTo) {

        $sql = "SELECT COUNT(DISTINCT ms.`id`) as 'result_count'  FROM  master_subscription ms ";
        $sql .= " LEFT JOIN `master_dealers` md ON md.id = ms.dealer_id   ";
        $sql .= " WHERE ms.id > 0";

        $sql .= " AND ms.`dealer_id`='{$searchDealer_id}'";

        $sql .= $transaction_type ? " AND ms.`transaction_type`  = '{$transaction_type}'  " : '';

        $sql .= $searchDateFrom ? " AND ms.`subscription_date_from`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND ms.`subscription_date_to`  <= '{$searchDateTo}' " : "";
//         echo   $sql."<hr>";

        return $this->masterDb->getOne($sql);
    }

    public function getDealerSubscriptions($aStart, $aLimit, $sort, $type, $searchDealer_id, $transaction_type, $searchDateFrom, $searchDateTo
    ) {
        $sql = "SELECT  ms.*,md.full_name  ";
        $sql .= "  FROM `master_subscription` ms ";
        $sql .= " LEFT JOIN `master_dealers` md ON md.id = ms.dealer_id   ";
        $sql .= " WHERE ms.id > 0";
        $sql .= " AND ms.dealer_id ='{$searchDealer_id}' ";
        $sql .= $transaction_type ? " AND ms.`transaction_type`  = '{$transaction_type}'  " : '';
        $sql .= $searchDateFrom ? " AND ms.`subscription_date_from`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND ms.`subscription_date_to`  <= '{$searchDateTo}' " : "";
        $sql .= " GROUP BY ms.`id`";
        $sql .= " ORDER BY  {$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//       echo $sql."<hr>"; 
        $res = $this->masterDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['balance'] = $this->getBalanceSumByDealer($res[$i]['dealer_id'], $res[$i]['id']);
            }
        }
        return $res;
    }

    public function addSubscriptions($temp) {
//        $balance = $this->getBalanceSumByDealer($temp['dealer_id']);
//        if ($temp['transaction_type'] == 'add_balance') {
//            $temp['balance'] = $balance + $temp['amount'];
//        } else if ($temp['transaction_type'] == 'commission_discount') {
//            $temp['balance'] = $balance - $temp['amount'];
//        } else if ($temp['transaction_type'] == 'get_balance') {
//            $temp['balance'] = $balance - $temp['amount'];
//        }

        $sql = "INSERT INTO `master_subscription` SET ";
        foreach ($this->masterDb->getCols('master_subscription', $temp) as $k => $v) {

            $sql .= ( $k == 'date_added' || $k == 'id') ? "" : "`{$k}`='{$v}',";
        }

        $sql .= " `date_added` = '{$this->dateTime}' ";
//            echo $sql . "<hr>";

        return $this->masterDb->queryreturnlastid($sql);
    }

    public function getBalanceSumByDealer($dealer_id, $id = '') {

        $sql = "SELECT amount,transaction_type FROM `{$this->mPrefix}master_subscription` ";
        $sql .= "WHERE dealer_id ='{$dealer_id}' and transaction_type IN('add_balance','commission_discount','get_balance') ";
        $sql .= $id ? " and id <= '{$id}' " : "";
        //            echo $sql . "<hr>";
        $res = $this->masterDb->getAll($sql);
        if ($res) {
            foreach ($res as $key => $value) {
                if ($value['transaction_type'] === 'add_balance') {
                    $add_balance[] = $value['amount'];
                } else if ($value['transaction_type'] === 'commission_discount') {
                    $commission_discount[] = $value['amount'];
                } else if ($value['transaction_type'] === 'get_balance') {
                    $get_balance[] = $value['amount'];
                }
            }

            $balance = array_sum($add_balance ?? []) - array_sum($commission_discount ?? []) - array_sum($get_balance ?? []);

//        $data['balance'] = number_format($data['balance'], 2, '.', '');


            return $balance;
        } else {
            return $res;
        }
    }

    public function getLastsubscriptionDateTo($dealer_id) {

        $sql = "SELECT subscription_date_to FROM `{$this->mPrefix}master_subscription` ";
        $sql .= "WHERE dealer_id ='{$dealer_id}' and transaction_type ='subscription_payment' ";
        $sql .= " ORDER BY  subscription_date_to DESC ";
        //            echo $sql . "<hr>";
        $res = $this->masterDb->getOne($sql);

        return $res;
    }

    public function getSubscriptionPeriod($dealer_id) {

        $sql = " SELECT  md.subscription_type,md.commission_rate,md.commission_value,md.minimum_commission,md.maximum_commission,";
        $sql .= " MIN(CASE WHEN md.subscription_type = 'period' AND ms.subscription_date_to >= NOW() THEN ms.subscription_date_from END) as subscription_date_from,";
        $sql .= " MAX(CASE WHEN md.subscription_type = 'period' AND ms.subscription_date_to >= NOW() THEN ms.subscription_date_to END) as subscription_date_to";
        $sql .= " FROM master_dealers md ";
        $sql .= " LEFT JOIN  master_subscription ms ON md.id = ms.dealer_id ";
        $sql .= " WHERE  md.id = '{$dealer_id}'";
        $sql .= " GROUP BY  md.subscription_type;";
//        $sql = "SELECT (SELECT md.subscription_type FROM `{$this->mPrefix}master_dealers` md  WHERE md.id =ms.dealer_id ) as subscription_type ,ms.`subscription_date_from`,MAX(ms.`subscription_date_to`) as subscription_date_to FROM `{$this->mPrefix}master_subscription` ms  ";
//        $sql .= " WHERE ms.dealer_id ='{$dealer_id}' and ms.subscription_date_to >=NOW() ";
//        echo $sql."<hr>";
        return $this->masterDb->getRow($sql);
    }

    public function deleteSubscriptionItemsByInvoice($data) {

        $sql2 = "DELETE FROM `master_subscription` ";
        $sql2 .= " WHERE `dealer_id` = '{$data['dealer_id']}' and  transaction_id ='{$data['transaction_id']}'  and  count_invoice_type ='{$data['count_invoice_type']}'";

        return $this->masterDb->query($sql2);
    }
}
