<?php

$favoritesObj = new Favorites();

class Favorites {

    public Iplus $mDb;
    public array $mConfig;
    public string $lang_code;
    public string $dateTime;
    public string $date;
    public Notifications $notifications;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->notifications = new Notifications();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->date = date('Y-m-d');
        $this->lang_code = LANGUAGE; // Default to 'en' if LANGUAGE is not defined
    }

    public function getFavorites(
            $aStart, $aLimit, $sort, $type, $searchDateFrom, $searchDateTo, $searchKey, $searchClient_id, $searchSendStatus, $searchAffiliator_id, $searchTrademark_id, $searchServiceId
    ) {
        global $productsObj;
        if ($searchServiceId) {
            $chidIds = $productsObj->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
                // p($searchServiceId);
            }
        }

        $sql = "SELECT p.product_code ,p.product_barcode , pa.* , pl.product_id  , pl.name  as product_name   , u2.user_name as affiliator_name  , u.last_name as client_last_name, u.user_name as client_name   FROM `favorites` pa";

        $sql .= " LEFT JOIN `users` u ON u.id = pa.client_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = pa.affiliator_id ";

        $sql .= " LEFT JOIN `products` p ON p.id = pa.product_id    ";
        $sql .= " LEFT JOIN `product_langs` pl ON p.id = pl.product_id  AND pl.lang_code = '{$this->lang_code}'   ";
        $sql .= " LEFT JOIN `product_services` pse ON pse.product_id = p.id ";

        $sql .= " LEFT JOIN `expiration_date` ed ON ed.product_id = p.id ";

        $sql .= " WHERE pa.id > 0 ";
        $sql .= $searchDateFrom ? " AND pa.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND pa.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . ' OR  ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR  ' . search_word_in_column('pl.`name`', $searchKey) . ')' : '';
        $sql .= $searchTrademark_id ? " AND p.`trademark_id` =  '{$searchTrademark_id}'" : "";
        $sql .= $searchServiceId ? " AND pse.`service_id` in  ({$searchServiceId})  " : "";
        $sql .= $searchClient_id ? " AND pa.`client_id` =  '{$searchClient_id}'  " : "";
        $sql .= $searchAffiliator_id ? " AND pa.`affiliator_id` =  '{$searchAffiliator_id}'  " : "";
        $sql .= $searchSendStatus ? " AND pa.`notify_status` =  '{$searchSendStatus}'  " : "";

        $sql .= " group by  pa.id ";

        $sql .= $sort ? " ORDER BY pa.{$sort} {$type}" : " ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//         echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['product_services'] = $productsObj->getProduct_services($res[$i]['product_id']);
                $res[$i]['ser_name'] = $productsObj->getAllServicesNameOfProductById($res[$i]['product_id']);
                $res[$i]['images'] = $productsObj->getProductimgs($res[$i]['product_id']);

                $res[$i]['image'] = $res[$i]['images'][0]['name'];
            }
        }
        return $res;
    }

    public function getSearchFavoritesCount(
            $searchDateFrom, $searchDateTo, $searchKey, $searchClient_id, $searchSendStatus, $searchAffiliator_id, $searchTrademark_id, $searchServiceId
    ) {
        global $productsObj;
        if ($searchServiceId) {
            $chidIds = $productsObj->getIdsOfChidService($searchServiceId);
            if ($chidIds) {
                $searchServiceId .= ',' . $chidIds;
                // p($searchServiceId);
            }
        }
        $sql = "SELECT COUNT(DISTINCT  pa.`id`) AS 'result_count'  FROM `favorites` pa";
        $sql .= " LEFT JOIN `products` p ON p.id = pa.product_id    ";
        $sql .= " LEFT JOIN `product_langs` pl ON p.id = pl.product_id  AND pl.lang_code = '{$this->lang_code}'   ";
        $sql .= " LEFT JOIN `product_services` pse ON pse.product_id = p.id ";

        $sql .= " LEFT JOIN `expiration_date` ed ON ed.product_id = p.id ";

        $sql .= " WHERE pa.id > 0 ";
        $sql .= $searchDateFrom ? " AND pa.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND pa.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $searchKey ? ' AND ( ' . search_word_in_column('p.`product_code`', $searchKey) . '  OR ' . search_word_in_column('p.`product_barcode`', $searchKey) . ' OR ' . search_word_in_column('pl.`name`', $searchKey) . ' )' : '';
        $sql .= $searchTrademark_id ? " AND p.`trademark_id` =  '{$searchTrademark_id}'" : "";
        $sql .= $searchServiceId ? " AND pse.`service_id` in  ({$searchServiceId})  " : "";
        $sql .= $searchClient_id ? " AND pa.`client_id` =  '{$searchClient_id}'  " : "";
        $sql .= $searchAffiliator_id ? " AND pa.`affiliator_id` =  '{$searchAffiliator_id}'  " : "";
        $sql .= $searchSendStatus ? " AND pa.`notify_status` =  '{$searchSendStatus}'  " : "";

        //  p($sql);
        return $this->mDb->getOne($sql);
    }

    public function deleteFavorites($ids) {

        $sql = "DELETE FROM `favorites` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }
}
