<?php

$hs256Obj = new hs256();

class hs256 {

    public $mDb;
    public $mConfig;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function base64UrlEncode($data) {
        $urlSafeData = strtr(base64_encode($data), '+/', '-_');

        return rtrim($urlSafeData, '=');
    }

function base64UrlDecode($data = '') {
    if (empty($data)) {
        return ''; // إعادة سلسلة فارغة إذا كان $data فارغًا أو null
    }

    $urlUnsafeData = strtr($data, '-_', '+/');
    
    // إذا لم يكن الطول من مضاعفات 4، قم بإضافة padding
    $mod = strlen($urlUnsafeData) % 4;
    if ($mod > 0) {
        $urlUnsafeData .= str_repeat('=', 4 - $mod);
    }

    return base64_decode($urlUnsafeData);
}

    function generateJWT($algo, array $header, array $payload) {

        $secret = 'IT-PLUS.co@147';

        $headerEncoded = $this->base64UrlEncode(json_encode($header));

        $payloadEncoded = $this->base64UrlEncode(json_encode($payload));

        // Delimit with period (.)
        $dataEncoded = "$headerEncoded.$payloadEncoded";

        $rawSignature = hash_hmac($algo, $dataEncoded, $secret, true);

        $signatureEncoded = $this->base64UrlEncode($rawSignature);

        // Delimit with second period (.)
        $jwt = "$dataEncoded.$signatureEncoded";

        return $jwt;
    }

 function verifyJWT($algo = '', $jwt = '') {
    $secret = 'IT-PLUS.co@147';
    $newjwt = substr($jwt, 7);

    // تقسيم المتغير والتحقق من وجود الثلاثة أجزاء
    $jwtParts = explode('.', $newjwt);
    if (count($jwtParts) !== 3) {
        // إعادة خطأ أو قيمة false إذا لم يكن هناك ثلاثة أجزاء
        return false;
    }

    list($headerEncoded, $payloadEncoded, $signatureEncoded) = $jwtParts;

    $dataEncoded = "$headerEncoded.$payloadEncoded";

    $signature = $this->base64UrlDecode($signatureEncoded);

    $rawSignature = hash_hmac($algo, $dataEncoded, $secret, true);

    return hash_equals($rawSignature, $signature);
}
    
    
}

?>