<?php

$reportObj = new Reports();

class Reports
{
    public Iplus $mDb;
    public Users $userObj;
    public array $mConfig;
    public string $lang;
    public string $dateTime;
    public PushMessage $pushNotify;

    public function __construct()
    {
        global $Config;

        $this->mDb = new Iplus();
        $this->userObj = new Users();
        $this->mConfig = $Config;
        $this->pushNotify = new PushMessage();
        $this->lang = defined('LANGUAGE') ? LANGUAGE : 'en'; // Default to 'en' if LANGUAGE is not defined
        $this->dateTime = date('Y-m-d H:i:s');
    }

    function getVisitorsByParams(
    $aStart, $aLimit, $sort, $type, $searchVisitorType, $searchSet_from, $searchAffiliator_id, $searchClient_id, $searchDateFrom, $searchDateTo
    ) {
        // echo "$affiliator_id";die();
        $sql = "SELECT v.*  , u.last_name AS 'client_last_name', u.user_name AS 'client_name' ,u2.user_name as affiliator_name FROM visits_reports v ";
        $sql .= " LEFT JOIN `users` u ON u.id = v.client_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id =  v.affiliator_id ";
        $sql .= " WHERE v.id > 0  ";

        $sql .= $searchVisitorType == 'visitor' ? " AND v.client_id  = '0' " : '';
        $sql .= $searchVisitorType == 'registered' ? " AND v.client_id  > '0' " : '';
        $sql .= $searchVisitorType == 'registered' && $searchClient_id ? " AND v.client_id  = '{$searchClient_id}' " : '';
        $sql .= $searchDateFrom ? " AND v.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND v.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchSet_from ? " AND v.set_from  = '{$searchSet_from}'" : '';
        $sql .= $searchAffiliator_id ? " AND v.affiliator_id = '{$searchAffiliator_id}' " : ' ';

        $sql .= " Group by v.id ORDER BY v.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
        //  echo $sql; die();

        $res = $this->mDb->getAll($sql);


        return $res;
    }

    function getVisitorsAdminByParams(
    $aStart, $aLimit, $sort, $type, $searchVisitorType, $search_device_type, $searchAffiliator_id, $searchUser_id, $searchDateFrom, $searchDateTo
    ) {

        $sql = "SELECT v.*  , u.user_name AS 'admin_name'  FROM log_visits_admin v ";
        $sql .= " LEFT JOIN `users` u ON u.id = v.user_id ";
        $sql .= " WHERE v.id > 0  ";


        $sql .= $searchDateFrom ? " AND v.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND v.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $search_device_type ? " AND v.device_type  = '{$search_device_type}'" : '';
        $sql .= $searchUser_id ? " AND v.user_id  = '{$searchUser_id}' " : '';

        $sql .= " Group by v.id ORDER BY v.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//          echo $sql."<hr>";

        $res = $this->mDb->getAll($sql);


        return $res;
    }

    function getSearchVisitorsCount(
    $searchVisitorType, $searchSet_from, $searchAffiliator_id, $searchClient_id, $searchDateFrom, $searchDateTo
    ) {
        // echo "$affiliator_id";die()
        $sql = "SELECT count(v.id) FROM visits_reports v ";
        $sql .= " WHERE v.id > 0  ";


        $sql .= $searchVisitorType == 'visitor' ? " AND v.client_id  = '0' " : '';
        $sql .= $searchVisitorType == 'registered' ? " AND v.client_id  > '0' " : '';

        $sql .= $searchVisitorType == 'registered' && $searchClient_id ? " AND v.client_id  = '{$searchClient_id}' " : '';

        $sql .= $searchDateFrom ? " AND v.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND v.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchSet_from ? " AND v.set_from  = '{$searchSet_from}'" : '';
        $sql .= $searchAffiliator_id ? " AND v.affiliator_id = '{$searchAffiliator_id}' " : ' ';
        // echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getSearchVisitorsAdminCount(
    $searchVisitorType, $search_device_type, $searchAffiliator_id, $searchUser_id, $searchDateFrom, $searchDateTo
    ) {
        // echo "$affiliator_id";die()
        $sql = "SELECT count(v.id) FROM log_visits_admin v ";
        $sql .= " WHERE v.id > 0  ";
        $sql .= $searchDateFrom ? " AND v.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND v.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $search_device_type ? " AND v.device_type  = '{$search_device_type}'" : '';
        $sql .= $searchUser_id ? " AND v.user_id  = '{$searchUser_id}' " : '';
//          echo $sql."<hr>";
        return $this->mDb->getOne($sql);
    }

    function deleteVisitor($ids) {

        $sql = "DELETE FROM `visits_reports` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    function getSearchingsByParams(
    $aStart, $aLimit, $sort, $type, $searchVisitorType, $searchSet_from, $searchAffiliator_id, $searchClient_id, $searchDateFrom, $searchDateTo, $searchKey
    ) {
        // echo "$affiliator_id";die();
        $sql = "SELECT s.* , u.last_name AS 'client_last_name', u.user_name AS 'client_name' ,u2.user_name as affiliator_name ,sl.ser_name  FROM search_product_reports s ";
        $sql .= " LEFT JOIN `users` u ON u.id = s.client_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id =  s.affiliator_id ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.searchCategoryId = sl.service_id  and sl.lang_code = 'ar'";


        $sql .= " WHERE s.id > 0  ";

        $sql .= $searchKey ? ' AND     ( s.searchKey like "%' . $searchKey . '%"  ||  sl.ser_name like "%' . $searchKey . '%" )  ' : ' ';
        $sql .= $searchVisitorType == 'visitor' ? " AND s.client_id  = '0' " : '';
        $sql .= $searchVisitorType == 'registered' ? " AND s.client_id  > '0' " : '';
        $sql .= $searchVisitorType == 'registered' && $searchClient_id ? " AND s.client_id  = '{$searchClient_id}' " : '';
        $sql .= $searchDateFrom ? " AND s.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND s.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchSet_from ? " AND s.set_from  = '{$searchSet_from}'" : '';
        $sql .= $searchAffiliator_id ? " AND s.affiliator_id = '{$searchAffiliator_id}' " : ' ';

        $sql .= " Group by s.id ORDER BY s.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
        //  echo $sql; die();

        $res = $this->mDb->getAll($sql);
        // if ($res) {
        //   for ($i = 0; $i < count($res); $i++) {
        //     # code...
        //   }
        //   # code...
        // }


        return $res;
    }

    function getSearchSearchingsCount(
    $searchVisitorType, $searchSet_from, $searchAffiliator_id, $searchClient_id, $searchDateFrom, $searchDateTo, $searchKey
    ) {
        // echo "$affiliator_id";die()
        $sql = "SELECT count(s.id) FROM search_product_reports s ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.searchCategoryId = sl.service_id and sl.lang_code = 'ar' ";

        $sql .= " WHERE s.id > 0  ";

        $sql .= $searchKey ? ' AND     ( s.searchKey like "%' . $searchKey . '%"  ||  sl.ser_name like "%' . $searchKey . '%" )  ' : ' ';
        $sql .= $searchVisitorType == 'visitor' ? " AND s.client_id  = '0' " : '';
        $sql .= $searchVisitorType == 'registered' ? " AND s.client_id  > '0' " : '';

        $sql .= $searchVisitorType == 'registered' && $searchClient_id ? " AND s.client_id  = '{$searchClient_id}' " : '';

        $sql .= $searchDateFrom ? " AND s.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND s.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchSet_from ? " AND s.set_from  = '{$searchSet_from}'" : '';
        $sql .= $searchAffiliator_id ? " AND s.affiliator_id = '{$searchAffiliator_id}' " : ' ';
        // echo $sql;
        // die();
        return $this->mDb->getOne($sql);
    }

    function deleteSearching($ids) {

        $sql = "DELETE FROM `search_product_reports` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

}
