<?php

$servicesObj = new Services();

class Services {

    private $mDb;
    private $mConfig;
    private $dateTime;
    private $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getServicesByParams(
            $aStart = '', $aLimit = '', $sort = '', $type = '', $searchName = '', $parent_id = '', $service_type = '', $serviceStatus = '', $searchUser_id = '', $searchUserType = ''
    ) {

        $chidIdsAffiliatorSerivce = '';
        if ($searchUserType === 'affiliator' && ($parent_id === '0' || !$parent_id)) {
            $chidIdsAffiliatorSerivce = '-1';
            $data = $this->getIdsOfAffiliatorServices($searchUser_id);
            // p($data );
            if ($data) {
                $chidIdsAffiliatorSerivce .= ',' . $data;
                // p($searchServiceId);
            }
        }


        // echo "$parent_id";die();
        $sql = "SELECT s.* , sl.ser_name ,sl2.ser_name as parentName, u.user_name AS 'addedBy' FROM services s ";
        $sql .= " LEFT JOIN `users` u ON u.id = s.admin_id ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id ";
        $sql .= " LEFT JOIN `service_langs` sl2 ON s.parent = sl2.service_id ";

        $sql .= " WHERE s.id > 0 AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= $chidIdsAffiliatorSerivce ? " AND s.id in  ({$chidIdsAffiliatorSerivce})  " : "";

        $sql .= $searchName && $searchName != 'undefined' ? ' AND (sl.ser_name like "%' . $searchName . '%" || s.key_word like "%' . $searchName . '%" ) ' : '';
        $sql .= ($parent_id === '0' || $parent_id) ? " AND s.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type === 'subService' ? " AND s.parent > '0' " : "";
        $sql .= $service_type === 'mainService' ? " AND s.parent = '0' " : "";
        $sql .= ($serviceStatus === '0' || $serviceStatus) ? " AND s.active = '{$serviceStatus}' " : ' ';

        $sql .= " Group by s.id ORDER BY s.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//            echo $sql."<hr>";

        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $res[$i]['countOfProd'] = $this->getCountOfProdByServiceId($res[$i]['id']);

                $res[$i]['haveSubService'] = $res[$i]['countOfProd'] == 0 ? $this->cheackIfServieHaveSubService($res[$i]['id']) : false;
            }
        }

        return $res;
    }

    function getSupportAndBlogCategoryByParams(
            $aStart = '', $aLimit = '', $sort = '', $type = '', $searchName = '', $parent_id = '', $service_type = '', $serviceStatus = '', $affiliators_ids = array()
    ) {


        $sql = "SELECT c.* , cl.name ,cl2.name as parentName, u.user_name AS 'addedBy' FROM support_and_blog_category c ";
        $sql .= " LEFT JOIN `users` u ON u.id = c.admin_id ";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON c.id = cl.cat_id AND cl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl2 ON c.parent = cl2.cat_id AND cl2.lang_code = '{$this->lang_code}' ";

        $sql .= " WHERE c.id > 0  ";

        $sql .= $searchName ? ' AND (cl.name like "%' . $searchName . '%" ) ' : '';
        $sql .= count($affiliators_ids) > 0 ? ' and ( c.affiliators_ids like "%,-1,%" ' : "";
        foreach ($affiliators_ids as $k => $v) {
            if ($v) {
                $sql .= ' ||  (c.affiliators_ids like "%,' . $v . ',%" ) ';
            }
        }
        $sql .= count($affiliators_ids) > 0 ? ' ) ' : '';

        $sql .= ($parent_id === '0' || $parent_id) ? " AND c.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type === 'subService' ? " AND c.parent > '0' " : '';
        $sql .= $service_type === 'mainService' ? " AND c.parent = '0' " : '';
        $sql .= ($serviceStatus === '0' || $serviceStatus) ? " AND c.active = '{$serviceStatus}' " : ' ';

        $sql .= " Group by c.id ORDER BY c.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//     echo $sql; 
//p($affiliators_ids);
        $res = $this->mDb->getAll($sql);

        return $res;
    }

    public function getCountOfProdByServiceId($id) {
        $sql = "SELECT COUNT(DISTINCT product_id) FROM `product_services` WHERE `service_id` = :service_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':service_id', $id);
        $stmt->execute();

        // Return the count, or 0 if no rows found
        return $stmt->fetchColumn() ?: 0; // إذا كانت النتيجة false، ارجع 0
    }

    function cheackIfServieHaveSubService($id) {
        $sql = "SELECT count(id) FROM `services`";
        $sql .= " WHERE `parent` = '{$id}' ";
        $res = $this->mDb->getOne($sql);
        return $res ? true : false;
    }

    function getSearchServicesCount(
            $searchName = '', $parent_id = '', $service_type = '', $serviceStatus = '', $searchUser_id = '', $searchUserType = ''
    ) {



        if ($searchUserType == 'affiliator' && ($parent_id == '0' || !$parent_id)) {
            $chidIdsAffiliatorSerivce = '-1';
            $data = $this->getIdsOfAffiliatorServices($searchUser_id);
            // p($data );
            if ($data) {
                $chidIdsAffiliatorSerivce .= ',' . $data;
                // p($searchServiceId);
            }
        }


        $sql = "SELECT COUNT(DISTINCT s.id) as 'result_count' FROM services s ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id ";

        $sql .= " WHERE s.id > 0 AND sl.lang_code = '{$this->lang_code}' ";

        $sql .= $chidIdsAffiliatorSerivce ? " AND s.id in  ({$chidIdsAffiliatorSerivce})  " : "";

        $sql .= $searchName ? ' AND (sl.ser_name like "%' . $searchName . '%" || s.key_word like "%' . $searchName . '%" ) ' : '';
        $sql .= ($parent_id === '0' || $parent_id) ? " AND s.parent = '{$parent_id}' " : ' ';
        $sql .= $service_type == 'subService' ? " AND s.parent > '0' " : "";
        $sql .= $service_type == 'mainService' ? " AND s.parent = '0' " : "";
        $sql .= ($serviceStatus === '0' || $serviceStatus) ? " AND s.active = '{$serviceStatus}' " : ' ';

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function addEditService($temp) {





        $temp['service_system_commission'] = $temp['service_system_commission'] ? $temp['service_system_commission'] : '0';
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['expiration_date'] = $temp['expiration_date'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';
        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `services` SET ";
            foreach ($this->mDb->getCols('services', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `service_langs` SET  lang_code = '{$v['lang_code']}' , ser_name = '{$v['details']['ser_name']}', ser_description = '{$v['details']['ser_description']}' ,service_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }
            }
            return $res;
        } else {


            // edit
            if ($temp['ser_image'] == '') { //remove image if we removed
                $image = $this->getimg($temp['id']);
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/services/' . $image;
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
            }

            $sql = "UPDATE `services` SET ";
            foreach ($this->mDb->getCols('services', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `service_langs` ";
                $sql .= " WHERE service_id='{$temp['id']}'  ";
                $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `service_langs` SET  lang_code = '{$v['lang_code']}' , ser_name = '{$v['details']['ser_name']}' , ser_description = '{$v['details']['ser_description']}' ,service_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                }
                # code...





                $this->deleteSerSliders($temp['id']);
                $this->addSerSliders($temp['sliders'], $temp['id']);
            }

            return $res;
        }
    }

    public function getSerSliders($id) {
        $sql = "SELECT id, name, lang_code FROM service_sliders WHERE service_id = :service_id";
         $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':service_id', $id);
        $stmt->execute();

        return $stmt->fetchAll(PDO::FETCH_ASSOC); // إرجاع النتائج كمصفوفة مرتبطة
    }

    public function deleteSerSliders($service_id) {
        $sql = "DELETE FROM `{$this->mPrefix}service_sliders` WHERE service_id = :service_id";
       $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':service_id', $service_id); // ربط المعامل بشكل آمن
        $stmt->execute(); // تنفيذ الاستعلام
    }

    public function addSerSliders($data, $service_id) {
        if (count($data) > 0) {
            // تأكد من أن service_id هو عدد صحيح
            $service_id = (int) $service_id; // تحويل إلى عدد صحيح
            // إعداد الاستعلام المحضر
            $sql = "INSERT INTO `{$this->mPrefix}service_sliders` (service_id, name, lang_code) VALUES (:service_id, :name, :lang_code)";
            $stmt = $this->mDb->connect()->prepare($sql);

            foreach ($data as $v) {
                if (!empty($v['name']) && !empty($v['lang_code'])) { // تحقق من القيم
                    $stmt->bindParam(':service_id', $service_id, PDO::PARAM_INT); // ربط service_id
                    $stmt->bindParam(':name', $v['name'], PDO::PARAM_STR); // ربط name
                    $stmt->bindParam(':lang_code', $v['lang_code'], PDO::PARAM_STR); // ربط lang_code
                    $stmt->execute(); // تنفيذ الاستعلام
                }
            }
        }
    }

    public function getOneService($id) {
        // تأكد من أن id هو عدد صحيح
        $id = (int) $id; // تحويل id إلى عدد صحيح
        // استعلام لجلب الخدمة
        $sql = "SELECT * FROM `services` WHERE `id` = :id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':id', $id, PDO::PARAM_INT); // ربط المعامل
        $stmt->execute();

        $res = $stmt->fetch(PDO::FETCH_ASSOC); // استرجاع النتيجة

        if ($res) {
            // استعلام لجلب البيانات المتعلقة باللغة
            $sql = "SELECT lang_code, ser_name, ser_description FROM `service_langs` WHERE `service_id` = :service_id";
            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':service_id', $id, PDO::PARAM_INT); // ربط المعامل
            $stmt->execute();
            $res['lang_parameter'] = $stmt->fetchAll(PDO::FETCH_ASSOC); // استرجاع النتائج
            // جلب الشرائح
            $res['sliders'] = $this->getSerSliders($id);
            // $res['specifications'] = $this->getSpecifications($id);
        }

        return $res; // إرجاع النتيجة
    }

    function getimg($id) {
        $sql = "SELECT `ser_image` FROM `services`";
        $sql .= " WHERE `id` = '{$id}' ";
        return $this->mDb->getOne($sql);
    }

    function deleteservice($ids) {

        $sql = "DELETE FROM `services` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {


            $image = $this->getimg($id);
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/services/' . $image;

            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    function getIdsOfAffiliatorServices($user_id) {
        $sql = "SELECT service_id FROM `affiliator_services` ";
        $sql .= " WHERE `user_id` = '{$user_id}' ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql ;
        //  p( $res);
        if ($res) {
            $ret = fetchArrayValue_from_dataBase($res, 'service_id');

            return $ret;
        }
    }

    function getServicesForExcelSheet() {

        $sql = "SELECT s.active , sch.active as parent_active , s.id , sl.ser_name   , slch.ser_name as parent_name  FROM services s ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = s.id  AND sl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `services` sch ON sch.id = s.parent ";
        $sql .= " LEFT JOIN `service_langs` slch ON slch.service_id = sch.id AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= " Group by s.id   ORDER BY s.parent ";
        return $this->mDb->getAll($sql);
    }

    function getTreeCategories($sort, $type, $searchName, $parent_id, $withChaild = false, $id = '') {


        $sql = "SELECT s.id , s.parent , s.key_word , s.ser_image , s.service_system_commission , sl.ser_name,sl.ser_description ,sl2.ser_name as parentName  FROM services s ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id  AND  sl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `service_langs` sl2 ON s.parent = sl2.service_id   AND  sl2.lang_code = '{$this->lang_code}'";

        $sql .= " LEFT JOIN `affiliator_services` af ON s.id = af.service_id   ";

        $sql .= " WHERE s.id > 0 AND s.active = '1' ";
        $sql .= $searchName ? ' AND (sl.ser_name like "%' . $searchName . '%" || s.key_word like "%' . $searchName . '%" )' : '';
        $sql .= ($parent_id === '0' || $parent_id) ? " AND s.parent = '{$parent_id}' " : ' ';
        $sql .= $id ? " AND  s.id = '{$id}' " : ' ';

        $sql .= $sort == 'ser_name' ? " group by s.id  ORDER BY sl.{$sort} {$type} " : "  group by s.id  ORDER BY s.{$sort} {$type} ";
//        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo LANGUAGE ;die();
//          echo $sql; die();
        $res = $this->mDb->getAll($sql);
        if (!empty($res) && is_array($res)) {
            foreach ($res as $i => $item) {
                // تحقق من أن `countOfProd` و `id` معرفين قبل الاستخدام
                $res[$i]['haveSubService'] = isset($item['countOfProd']) && $item['countOfProd'] == 0 ? $this->cheackIfServieHaveSubService($item['id']) : false;

                // التحقق من `$withChaild` قبل محاولة استدعاء `getTreeCategories`
                if (!empty($withChaild)) {
                    $res[$i]['subServices'] = $this->getTreeCategories($sort, $type, '', $item['id'], false);
                }
            }
        }

        return $res;
    }

    function getAllCategories() {
        $sql = "SELECT s.id , sl.ser_name  FROM services s ";
        $sql .= " LEFT JOIN `service_langs` sl ON s.id = sl.service_id  AND  sl.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `affiliator_services` af ON s.id = af.service_id   ";
        $sql .= " WHERE s.id > 0 AND s.active = '1' ";
        $sql .= " Group by s.id    ";
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);

        return $res;
    }
}
