<?php

$supportAndBlogPagesObj = new supportAndBlogPages();

class supportAndBlogPages {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;  // Default to 'en' if LANGUAGE is not defined
    }

    function getPages($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id, $searchParent_id, $searchCat_id) {

        $sql = "SELECT p.* ,pl.title,pl.description,cl.name cat_name,cls.name sub_name, u.user_name AS 'addedBy' , u2.user_name AS 'affiliator_name'   FROM support_and_blog_pages p";
        $sql .= " LEFT JOIN `support_and_blog_pages_langs` pl ON p.id = pl.page_id ";

        $sql .= " LEFT JOIN `support_and_blog_category_langs` cl ON cl.cat_id = p.cat_id AND cl.lang_code ='{$this->lang_code}'";
        $sql .= " LEFT JOIN `support_and_blog_category_langs` cls ON cls.cat_id = p.sub_id AND cl.lang_code ='{$this->lang_code}'";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = p.affiliator_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = p.admin_id ";

        $sql .= " WHERE p.id > 0  AND pl.lang_code ='{$this->lang_code}'  ";
        $sql .= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%" ' : '';
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchParent_id ? " AND p.`parent` ='{$searchParent_id}' " : " ";
        $sql .= $searchCat_id ? " AND p.`cat_id` ='{$searchCat_id}' " : " ";
        $sql .= " group by p.id";
        $sql .= " ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//     echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchPagesCount($sort, $type, $searchTitle, $searchAffiliator_id, $searchParent_id, $searchCat_id) {
        $sql = "SELECT COUNT(DISTINCT p.`id`) as 'result_count' FROM support_and_blog_pages p";
        $sql .= " LEFT JOIN `support_and_blog_pages_langs` pl ON p.id = pl.page_id ";
        $sql .= " WHERE p.`id` > 0";

        $sql .= $searchTitle ? ' AND pl.`title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchAffiliator_id ? " AND  p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= $searchParent_id ? " AND p.`parent` ='{$searchParent_id}' " : " ";
        $sql .= $searchCat_id ? " AND p.`cat_id` ='{$searchCat_id}' " : " ";
        $sql .= " ORDER BY p.{$sort} {$type}";

//      echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getPagesCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `support_and_blog_pages`";
        return $this->mDb->getOne($sql);
    }

    function addEditPage($temp) {
        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['show_in_header'] = $temp['show_in_header'] ? '1' : '0';
        $temp['show_in_footer'] = $temp['show_in_footer'] ? '1' : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `support_and_blog_pages` SET ";
            foreach ($this->mDb->getCols('support_and_blog_pages', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' || $k == 'img' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            $sql .= $temp['img'] == '' ? " , `img` = null" : ", `img` = '{$temp['img']}' ";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `support_and_blog_pages_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}' , description = '{$v['details']['description']}' , page_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }
            return $res;
        } else {

            $sql = "UPDATE `support_and_blog_pages` SET ";
            foreach ($this->mDb->getCols('support_and_blog_pages', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'img' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= $temp['img'] == '' ? " , `img` = null" : ", `img` = '{$temp['img']}' ";
            $sql .= " WHERE `id` = '{$temp['id']}'";
            echo $sql."<hr>";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `support_and_blog_pages_langs` ";
                $sql .= " WHERE page_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `support_and_blog_pages_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}' , description = '{$v['details']['description']}' ,page_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    function getOnePage($id) {
        $sql = "SELECT p.*  FROM `support_and_blog_pages` p ";
        $sql .= " WHERE p.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title ,description FROM `support_and_blog_pages_langs`";
            $sql .= " WHERE `page_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    function deletePage($ids) {
        $sql = "DELETE FROM `support_and_blog_pages` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        $res = $this->mDb->query($sql);
        if ($res) {
            $sql2 = "DELETE FROM `support_and_blog_pages_langs` ";
            $sql2 .= " WHERE `page_id` = '{$id}'";
            $this->mDb->query($sql2);
        }

        return $res;
    }
}

?>