<?php

$ticketsObj = new tickets();

class tickets {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; // Default to 'en' if LANGUAGE is not defined
    }

    public function getTickets($aStart, $aLimit, $sort, $type, $searckey, $searchDateFrom, $searchDateTo, $searchTicketStatus, $searchUser_id) {

        $sql = "SELECT t.* , u.user_name AS 'addedBy' FROM order_tickets t";
        $sql .= " LEFT JOIN `users` u ON u.id = t.user_id ";

        $sql .= " WHERE t.id > 0    ";

        $sql .= $searckey ? " AND t.id  = '{$searckey}' " : '';

        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchTicketStatus ? " AND t.`status` = '{$searchTicketStatus}' " : "";
        $sql .= $searchUser_id ? " AND t.`user_id` = '{$searchUser_id}' " : "";

        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    public function getSearchTicketsCount($sort, $type, $searckey, $searchDateFrom, $searchDateTo, $searchTicketStatus, $searchUser_id) {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'result_count' FROM order_tickets";
        $sql .= " WHERE `id` > 0";

        $sql .= $searckey ? " AND `id` = '{$searckey}' " : '';

        $sql .= $searchDateFrom ? " AND  `date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND  `date_added`  <= '{$searchDateTo}' " : "";
        $sql .= $searchTicketStatus ? " AND `status` = '{$searchTicketStatus}' " : "";
        $sql .= $searchUser_id ? " AND `user_id` = '{$searchUser_id}' " : "";

        $sql .= " ORDER BY {$sort} {$type}";

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    public function getTicketsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `order_tickets`";
        return $this->mDb->getOne($sql);
    }

    public function addEditTicket($temp) {

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `order_tickets` SET ";
            foreach ($this->mDb->getCols('order_tickets', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            //   echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
            }
            return $res;
        } else {

            $sql = "UPDATE `order_tickets` SET ";
            foreach ($this->mDb->getCols('order_tickets', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {
                
            }

            return $res;
        }
    }

    public function getOneTicket($id) {
        $sql = "SELECT * FROM `order_tickets`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    public function deleteTicket($ids) {
        $sql = "DELETE FROM `order_tickets` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function getOneTicketDetails($temp) {

        $sql = "SELECT t.* ,  u.user_name as addedBy FROM `order_tickets` t";
        $sql .= " LEFT JOIN `users` u ON u.id = t.user_id";
        $sql .= " WHERE t.`id` = '{$temp['id']}' ";

        // echo "<pre>";print_r($sql);die();

        $res = $this->mDb->getRow($sql);
        if ($res) {

            $res['ticketComments'] = $this->getTicketComments($temp['id']);
        }
        return $res;
    }

    public function getTicketComments($order_ticket_id) {
        $sql = "SELECT `otc`.*,    u.user_name as addedBy FROM `order_ticket_comments` otc ";
        $sql .= " LEFT JOIN `users` u ON u.id = otc.user_id";

        $sql .= " WHERE otc.order_ticket_id = '{$order_ticket_id}'  group by otc.id order by otc.id desc   ";
        //   echo "<pre>";print_r($sql);die();
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function sendComment($temp) {

        // echo '<pre>'; print_r($temp);die();
        $sql = "INSERT INTO `order_ticket_comments` SET ";
        foreach ($this->mDb->getCols('order_ticket_comments', $temp) as $k => $v) {
            $sql .= ($k == 'service_id' || $k == 'product_name' || $k == 'store') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}'  ";
        // echo $sql;die();
        return $this->mDb->query($sql);
    }

    public function changeTicketStatus($ids, $status, $admin_id) {
        $sql = "UPDATE `order_tickets` SET `status` = '{$status}' ";
        $sql .= " WHERE `id` < 0  ";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }
        //   echo "$sql";die();
        return $this->mDb->query($sql);
    }
}
